"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var hooks_1 = require("@steroidsjs/core/hooks");
var renderIcon_1 = __importDefault(require("../../utils/renderIcon"));
var ICON_SIZE = '_24x24';
function AccordionItemView(props) {
    var _a;
    var bem = (0, hooks_1.useBem)('AccordionItemView');
    React.useEffect(function () {
        if (!props.toggleAccordion || !props.toggleCollapse || !props.activeKey) {
            return;
        }
        if (props.hasOneOpenItem) {
            props.toggleAccordion(props.activeKey - 1);
        }
        else {
            props.toggleCollapse(props.activeKey - 1);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [props.activeKey]);
    var renderIcon = React.useCallback(function () {
        if (!props.icon) {
            return null;
        }
        if (typeof props.icon === 'object') {
            var icons = props.icon;
            return (React.createElement(React.Fragment, null,
                (0, renderIcon_1["default"])(icons.open, { className: bem.element('open-icon') }),
                (0, renderIcon_1["default"])(icons.close, { className: bem.element('close-icon') })));
        }
        return (0, renderIcon_1["default"])(props.icon, { className: bem.element('custom-icon') });
    }, [bem, props.icon]);
    var handleHeaderClick = React.useCallback(function () {
        if (props.disabled || !props.toggleAccordion || !props.toggleCollapse) {
            return;
        }
        var toggleAccordion = props.toggleAccordion, toggleCollapse = props.toggleCollapse, hasOneOpenItem = props.hasOneOpenItem, childIndex = props.childIndex;
        if (hasOneOpenItem) {
            toggleAccordion(childIndex);
        }
        else {
            toggleCollapse(childIndex);
        }
    }, [props]);
    return (React.createElement("div", { className: bem(bem.block((_a = {
                disable: props.disabled
            },
            _a["position_".concat(props.position)] = !!props.position,
            _a["theme_".concat(props.theme)] = !!props.theme,
            _a.opened = !props.disabled && props.isShowMore,
            _a)), props.className), style: props.style },
        React.createElement("div", { className: bem.element('header-container'), onClick: handleHeaderClick },
            React.createElement("div", { className: bem.element('title-container') },
                React.createElement("p", null, props.title)),
            props.showIcon && (React.createElement("div", { className: bem.element('icon-wrapper') }, props.icon
                ? renderIcon()
                : (React.createElement(Icon_1["default"], { className: bem.element('icon-chevron', {
                        active: !props.disabled && props.isShowMore
                    }), name: "arrow_down_24x24" }))))),
        React.createElement("div", { className: bem.element('content', { visible: !props.disabled && props.isShowMore }) }, props.children)));
}
exports["default"] = AccordionItemView;
