"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var moment_1 = __importDefault(require("react-day-picker/moment"));
var react_1 = require("react");
var hooks_1 = require("@steroidsjs/core/hooks");
var react_day_picker_1 = __importStar(require("react-day-picker"));
var CaptionElement_1 = __importDefault(require("./CaptionElement"));
function CalendarView(props) {
    var bem = (0, hooks_1.useBem)('CalendarView');
    var localeComponent = (0, hooks_1.useComponents)().locale;
    //TODO Исправить тип, связано с yarn tsc в action publish.yml
    var DayPicker = react_day_picker_1["default"];
    var month = props.month, toYear = props.toYear, fromYear = props.fromYear, showFooter = props.showFooter, onDaySelect = props.onDaySelect, selectedDates = props.selectedDates, onMonthSelect = props.onMonthSelect, numberOfMonths = props.numberOfMonths, toggleCaptionPanel = props.toggleCaptionPanel, isCaptionPanelVisible = props.isCaptionPanelVisible;
    var isRange = !!selectedDates[0] && !!selectedDates[1];
    var _a = (0, react_1.useMemo)(function () {
        var from = selectedDates[0];
        var to = selectedDates[1];
        var inRange = function (day) { return react_day_picker_1.DateUtils.isDayAfter(day, from) && react_day_picker_1.DateUtils.isDayBefore(day, to); };
        var outRange = function (day) { return react_day_picker_1.DateUtils.isDayBefore(day, from); };
        return {
            selectedDays: isRange
                ? [from, { from: from, to: to }]
                : from,
            modifiers: isRange && !react_day_picker_1.DateUtils.isSameDay(from, to)
                ? {
                    start: from,
                    end: to,
                    inRange: inRange
                }
                : undefined
        };
    }, [isRange, selectedDates]), selectedDays = _a.selectedDays, modifiers = _a.modifiers;
    return (React.createElement(DayPicker, __assign({}, props, { className: bem(bem.block({ ranged: isRange }), props.className), captionElement: (0, react_1.useCallback)(function (_a) {
            var classNames = _a.classNames, date = _a.date, localeUtils = _a.localeUtils, locale = _a.locale;
            return (React.createElement(CaptionElement_1["default"], { date: date, locale: locale, toYear: toYear, fromYear: fromYear, classNames: classNames, onChange: onMonthSelect, localeUtils: localeUtils, showCalendarFooter: showFooter, toggleCaptionPanel: toggleCaptionPanel, isCaptionPanelVisible: isCaptionPanelVisible }));
        }, [fromYear, isCaptionPanelVisible, onMonthSelect, showFooter, toYear, toggleCaptionPanel]), renderDay: function (day) {
            var date = day.getDate();
            return (React.createElement("div", { className: bem.element('day') }, date));
        }, todayButton: showFooter && (isCaptionPanelVisible ? __('Закрыть') : __('Сегодня')), onTodayButtonClick: function (day) {
            if (isCaptionPanelVisible) {
                toggleCaptionPanel();
            }
            else {
                onDaySelect(day);
            }
        }, fixedWeeks: true, month: month, firstDayOfWeek: 1, modifiers: modifiers, canChangeMonth: false, onDayClick: onDaySelect, selectedDays: selectedDays, numberOfMonths: numberOfMonths, localeUtils: moment_1["default"], locale: localeComponent.language })));
}
exports["default"] = CalendarView;
