"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var react_1 = require("react");
var hooks_1 = require("@steroidsjs/core/hooks");
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var upperFirst_1 = __importDefault(require("lodash-es/upperFirst"));
var DateControlType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/DateControlType"));
function CaptionElement(props) {
    var bem = (0, hooks_1.useBem)('CaptionElement');
    var localeUtils = props.localeUtils, locale = props.locale, fromYear = props.fromYear, toYear = props.toYear, date = props.date, isCaptionPanelVisible = props.isCaptionPanelVisible, toggleCaptionPanel = props.toggleCaptionPanel;
    var currentMonth = date.getMonth();
    var currentYear = date.getFullYear();
    var handleYearChange = function (newYear) {
        if (newYear !== currentYear) {
            props.onChange(new Date(newYear, currentMonth));
        }
    };
    var handleMonthChange = function (newMonth) {
        if (newMonth !== currentMonth) {
            props.onChange(new Date(currentYear, newMonth));
        }
    };
    var months = (0, react_1.useMemo)(function () { return (localeUtils.getMonths(locale).map(function (item, index) { return ({
        id: index,
        label: (0, upperFirst_1["default"])(item)
    }); })); }, [localeUtils, locale]);
    var years = (0, react_1.useMemo)(function () {
        var result = [];
        for (var i = fromYear.getFullYear(); i <= toYear.getFullYear(); i += 1) {
            result.push(i);
        }
        return result;
    }, [fromYear, toYear]);
    var icons = (0, react_1.useMemo)(function () { return [
        {
            name: 'double_arrow_left',
            sourceControl: DateControlType_1["default"].PREV_DOUBLE,
            onClick: function () { return handleYearChange(currentYear - 1); }
        },
        {
            name: 'arrow_left_24x24',
            sourceControl: DateControlType_1["default"].PREV_ONE,
            onClick: function () { return handleMonthChange(currentMonth - 1); }
        },
        {
            name: 'arrow_right_24x24',
            sourceControl: DateControlType_1["default"].NEXT_ONE,
            onClick: function () { return handleMonthChange(currentMonth + 1); }
        },
        {
            name: 'double_arrow_right',
            sourceControl: DateControlType_1["default"].NEXT_DOUBLE,
            onClick: function () { return handleYearChange(currentYear + 1); }
        },
    ]; }, [currentYear, handleYearChange, currentMonth, handleMonthChange]);
    return (React.createElement("div", { className: bem(bem.block()) },
        React.createElement("div", { className: bem.element('container') },
            React.createElement("div", { className: bem.element('content-container'), onKeyPress: function (e) {
                    e.preventDefault();
                    toggleCaptionPanel();
                }, onClick: function (e) {
                    e.preventDefault();
                    toggleCaptionPanel();
                }, role: 'button', tabIndex: 0 },
                React.createElement("span", { className: bem.element('selected-month') }, months.find(function (month) { return month.id === currentMonth; }).label),
                React.createElement("span", { className: bem.element('selected-year') }, years.find(function (year) { return year === currentYear; }))),
            React.createElement("div", { className: bem.element('container-icons') }, icons.map(function (icon, iconIndex) { return (React.createElement(Icon_1["default"], { key: iconIndex, name: icon.name, onClick: function (e) {
                    e.preventDefault();
                    icon.onClick();
                }, className: bem.element('button'), "data-sourcecontrol": icon.sourceControl })); }))),
        isCaptionPanelVisible && (React.createElement("div", { className: bem.element('panel', { 'full-height': !props.showCalendarFooter }) },
            React.createElement("div", { className: bem.element('panel-header', 'months') }, __('Месяц')),
            React.createElement("div", { className: bem.element('panel-header', 'years') }, __('Год')),
            React.createElement("div", { className: bem.element('panel-column-months', 'first') },
                React.createElement("div", { className: bem.element('content-column') }, months.slice(0, 6).map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('panel-cell', {
                        selected: value.id === currentMonth
                    }), onKeyPress: function (e) {
                        e.preventDefault();
                        handleMonthChange(value.id);
                    }, onClick: function (e) {
                        e.preventDefault();
                        handleMonthChange(value.id);
                    }, role: 'button', tabIndex: 0 },
                    React.createElement("div", { className: bem.element('cell-value') }, value.label))); }))),
            React.createElement("div", { className: bem.element('panel-column-months', 'second') }, months.slice(6, 12).map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('panel-cell', {
                    selected: value.id === currentMonth
                }), onKeyPress: function (e) {
                    e.preventDefault();
                    handleMonthChange(value.id);
                }, onClick: function (e) {
                    e.preventDefault();
                    handleMonthChange(value.id);
                }, role: 'button', tabIndex: 0 },
                React.createElement("div", { className: bem.element('cell-value') }, value.label))); })),
            React.createElement("div", { className: bem.element('panel-column-years') }, years.map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('panel-cell', {
                    selected: value === currentYear
                }), onKeyPress: function (e) {
                    e.preventDefault();
                    handleYearChange(value);
                }, onClick: function (e) {
                    e.preventDefault();
                    handleYearChange(value);
                }, role: 'button', tabIndex: 0 },
                React.createElement("div", { className: bem.element('cell-value') }, value))); }))))));
}
exports["default"] = CaptionElement;
