"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable @typescript-eslint/no-shadow */
/* eslint-disable implicit-arrow-linebreak */
/* eslint-disable no-undef */
var Modal_1 = __importDefault(require("@steroidsjs/core/ui/modal/Modal"));
var form_1 = require("@steroidsjs/core/ui/form");
var Text_1 = __importDefault(require("@steroidsjs/core/ui/typography/Text/Text"));
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var isEmpty_1 = __importDefault(require("lodash-es/isEmpty"));
function CalendarSystemModalView(props) {
    var bem = (0, useBem_1["default"])('CalendarSystemModalView');
    var eventInitialValues = react_1["default"].useMemo(function () { return props.eventInitialValues; }, [props.eventInitialValues]);
    var callOnEventSubmit = function (fields) {
        return eventInitialValues ? props.onEventSubmit(fields, eventInitialValues) : props.onEventSubmit(fields);
    };
    return (react_1["default"].createElement(Modal_1["default"], { title: eventInitialValues ? __('Редактирование события') : __('Новое событие'), onClose: props.onClose, className: bem.block(), shouldCloseOnEsc: true, shouldCloseOnOverlayClick: true },
        react_1["default"].createElement(form_1.Form, { className: bem.element('default-form'), onSubmit: function (fields) {
                callOnEventSubmit(fields);
                props.onClose();
            }, initialValues: eventInitialValues !== null && eventInitialValues !== void 0 ? eventInitialValues : null, submitLabel: (0, isEmpty_1["default"])(eventInitialValues) ? __('Создать') : __('Сохранить') },
            react_1["default"].createElement("div", null,
                react_1["default"].createElement(Text_1["default"], { content: __('Наименование'), className: bem.element('label') }),
                react_1["default"].createElement(form_1.InputField, { attribute: 'title', required: true, className: bem.element('name-field') }),
                react_1["default"].createElement(form_1.DropDownField, { attribute: 'eventGroupId', items: props.eventGroups, placeholder: '\u0413\u0440\u0443\u043F\u043F\u0430', color: "primary", required: true, itemsContent: {
                        type: 'checkbox'
                    } })),
            react_1["default"].createElement("div", null,
                react_1["default"].createElement(Text_1["default"], { content: __('Время и дата'), className: bem.element('label') }),
                react_1["default"].createElement(form_1.DateTimeField, { attribute: 'date', required: true })),
            react_1["default"].createElement("div", null,
                react_1["default"].createElement(Text_1["default"], { content: __('Описание'), className: bem.element('label') }),
                react_1["default"].createElement(form_1.TextField, { attribute: 'description', required: true })))));
}
exports["default"] = CalendarSystemModalView;
