"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var Calendar_1 = __importDefault(require("@steroidsjs/core/ui/content/Calendar"));
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
var AsideHeader_1 = __importDefault(require("./AsideHeader"));
var AsideCalendars_1 = __importDefault(require("./AsideCalendars"));
var ContentHeader_1 = __importDefault(require("./ContentHeader"));
var MonthGrid_1 = __importDefault(require("./MonthGrid"));
var WeekGrid_1 = __importDefault(require("./WeekGrid"));
function CalendarSystemView(props) {
    var bem = (0, useBem_1["default"])('CalendarSystemView');
    return (react_1["default"].createElement("div", { className: bem(bem.block(), props.className), style: props.style },
        react_1["default"].createElement("aside", { className: bem.element('aside') },
            react_1["default"].createElement(AsideHeader_1["default"], { onClick: props.openCreateModal, className: bem.element('aside-header') }),
            react_1["default"].createElement(Calendar_1["default"], { showFooter: false, onMonthChange: props.onMonthChange }),
            react_1["default"].createElement(AsideCalendars_1["default"], { eventGroups: props.eventGroups, eventGroupsTitle: props.eventGroupsTitle, selectedCalendarGroupsIds: props.selectedCalendarGroups, onChangeEventGroupsIds: props.onChangeEventGroupsIds })),
        react_1["default"].createElement("div", { className: bem.element('content') },
            react_1["default"].createElement(ContentHeader_1["default"], { dateToDisplay: props.dateToDisplay, onChangeCalendarType: props.onChangeCalendarType, applyControl: props.applyControl }),
            props.calendarType === CalendarType_1["default"].MONTH
                ? (react_1["default"].createElement(MonthGrid_1["default"], { monthCalendarDays: props.monthCalendarDays, getEventsFromDate: props.getEventsFromDate, weekDays: props.weekDays, openEditModal: props.openEditModal, openCreateModal: props.openCreateModal }))
                : (react_1["default"].createElement(WeekGrid_1["default"], { allHours: props.allHours, getEventsFromDate: props.getEventsFromDate, currentWeekDays: props.currentWeekDays, openEditModal: props.openEditModal, openCreateModal: props.openCreateModal })))));
}
exports["default"] = CalendarSystemView;
