"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable jsx-a11y/no-noninteractive-element-interactions */
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var Text_1 = __importDefault(require("@steroidsjs/core/ui/typography/Text/Text"));
var nav_1 = require("@steroidsjs/core/ui/nav");
var content_1 = require("@steroidsjs/core/ui/content");
var DateControlType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/DateControlType"));
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
require("./ContentHeader.scss");
function ContentHeader(props) {
    var bem = (0, useBem_1["default"])('ContentHeader');
    return (react_1["default"].createElement("div", { className: bem.block() },
        react_1["default"].createElement(Text_1["default"], { content: props.dateToDisplay, className: bem.element('month') }),
        react_1["default"].createElement("ul", { className: bem.element('controls'), onClick: props.applyControl }, Object.entries(DateControlType_1["default"].getIcons()).map(function (_a, controlIndex) {
            var controlLabel = _a[0], controlIcon = _a[1];
            return (react_1["default"].createElement("li", { key: controlIndex, className: bem.element('controls-item'), "data-control": controlLabel },
                react_1["default"].createElement(content_1.Icon, { className: bem.element('controls-item-icon'), name: controlIcon })));
        })),
        react_1["default"].createElement(nav_1.ButtonGroup, { className: bem.element('measures'), items: CalendarType_1["default"], onClick: props.onChangeCalendarType, defaultActiveButton: CalendarType_1["default"].MONTH })));
}
exports["default"] = react_1["default"].memo(ContentHeader);
