"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable @typescript-eslint/no-shadow */
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
var Tooltip_1 = __importDefault(require("@steroidsjs/core/ui/layout/Tooltip/Tooltip"));
var slice_1 = __importDefault(require("lodash-es/slice"));
var get_1 = __importDefault(require("lodash-es/get"));
var form_1 = require("@steroidsjs/core/ui/form");
var useExpandClickAway_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/hooks/useExpandClickAway"));
var getFormattedExpandLabel_1 = require("../../../../../utils/getFormattedExpandLabel");
require("./MonthDay.scss");
var SIXTH_ELEMENT_INDEX = 6;
function MonthDay(props) {
    var bem = (0, useBem_1["default"])('MonthDay');
    var day = props.day, getEventsFromDate = props.getEventsFromDate;
    var _a = (0, useExpandClickAway_1["default"])(), isExpanded = _a.isExpanded, setIsExpanded = _a.setIsExpanded, monthDayRef = _a.triggerRef;
    var _b = react_1["default"].useMemo(function () {
        var callingDate = new Date(props.day.date);
        var events = getEventsFromDate(callingDate, CalendarType_1["default"].MONTH);
        var dayHasMoreThanSixEvents = events.length > 6;
        return {
            events: events,
            hasSixEvents: dayHasMoreThanSixEvents
        };
    }, [getEventsFromDate, props.day.date]), events = _b.events, hasSixEvents = _b.hasSixEvents;
    var formattedExpandLabel = react_1["default"].useMemo(function () { return (0, getFormattedExpandLabel_1.getFormattedExpandRestLabel)((0, slice_1["default"])(__spreadArray([], events, true), SIXTH_ELEMENT_INDEX)); }, [events]);
    var renderEvent = react_1["default"].useCallback(function (event, eventIndex) { return (react_1["default"].createElement(Tooltip_1["default"], { key: event.id, position: 'rightBottom', content: event.title, className: bem.element('tooltip') },
        react_1["default"].createElement("span", { className: bem.element('event'), "data-eventid": event.id },
            react_1["default"].createElement("span", { className: bem.element('event-dot'), style: { backgroundColor: event.color } }),
            event.title))); }, [bem]);
    var handleEventClick = react_1["default"].useCallback(function (event) {
        var eventFromHour = event.target;
        var eventId = (0, get_1["default"])(eventFromHour, 'dataset.eventid');
        if (!eventId) {
            return;
        }
        var requiredEvent = events.filter(function (hourEvent) { return hourEvent.id === Number(eventId); })[0];
        props.openEditModal(requiredEvent);
    }, [events, props]);
    return (react_1["default"].createElement("div", { className: bem(bem.block({
            outOfRange: day.outOfRange,
            isToday: day.isToday
        })), ref: monthDayRef, onClick: handleEventClick, onContextMenu: function (e) {
            e.preventDefault();
            props.openCreateModal();
        } },
        react_1["default"].createElement("div", { className: bem.element('wrapper') },
            react_1["default"].createElement("span", { className: bem.element('number') }, day.dayNumber.toString()),
            react_1["default"].createElement("div", { className: bem.element('content', {
                    isExpanded: isExpanded
                }) },
                events.map(renderEvent),
                hasSixEvents && !isExpanded && (react_1["default"].createElement(form_1.Button, { link: true, className: bem.element('expand-button'), onClick: function () { return setIsExpanded(true); } }, formattedExpandLabel))))));
}
exports["default"] = MonthDay;
