"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable @typescript-eslint/no-shadow */
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var calendar_1 = require("@steroidsjs/core/utils/calendar");
var form_1 = require("@steroidsjs/core/ui/form");
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
var slice_1 = __importDefault(require("lodash-es/slice"));
var get_1 = __importDefault(require("lodash-es/get"));
var Tooltip_1 = __importDefault(require("@steroidsjs/core/ui/layout/Tooltip/Tooltip"));
var useExpandClickAway_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/hooks/useExpandClickAway"));
var getFormattedExpandLabel_1 = require("../../../../../utils/getFormattedExpandLabel");
require("./WeekHour.scss");
var FOURTH_ELEMENT_INDEX = 3;
function WeekHour(props) {
    var bem = (0, useBem_1["default"])('WeekHour');
    var _a = (0, useExpandClickAway_1["default"])(), isExpanded = _a.isExpanded, setIsExpanded = _a.setIsExpanded, weekHourRef = _a.triggerRef;
    var _b = react_1["default"].useMemo(function () {
        var callingDate = new Date(props.dayOfWeek.date);
        var timeArray = props.hour.replace(':', '').split('');
        callingDate.setHours(Number(timeArray[0] + timeArray[1]), 0, 0, 0);
        var events = props.getEventsFromDate(callingDate, CalendarType_1["default"].WEEK);
        var hasOneEvent = events.length === 1;
        var hasTwoEvents = events.length === 2;
        var hasMoreThanTreeEvents = events.length >= 3;
        var hasMoreThanFourEvents = events.length > 3;
        return {
            events: events,
            hasOneEvent: hasOneEvent,
            hasTwoEvents: hasTwoEvents,
            hasTreeEvents: hasMoreThanTreeEvents,
            hasMoreThanFourEvents: hasMoreThanFourEvents
        };
    }, [props]), events = _b.events, hasOneEvent = _b.hasOneEvent, hasTwoEvents = _b.hasTwoEvents, hasTreeEvents = _b.hasTreeEvents, hasMoreThanFourEvents = _b.hasMoreThanFourEvents;
    var renderEvent = react_1["default"].useCallback(function (event, eventIndex) { return (react_1["default"].createElement(Tooltip_1["default"], { position: 'rightBottom', content: event.title, className: bem.element('tooltip'), key: eventIndex },
        react_1["default"].createElement("div", { className: bem.element('hour-event'), style: { backgroundColor: event.color }, title: event.title, "data-eventid": event.id },
            react_1["default"].createElement("span", { className: bem.element('hour-event-title') }, event.title),
            react_1["default"].createElement("span", { className: bem.element('hour-event-time') }, (0, calendar_1.convertDate)(event.date, null, 'HH:mm'))))); }, [bem]);
    var formattedExpandLabel = react_1["default"].useMemo(function () { return (0, getFormattedExpandLabel_1.getFormattedExpandRestLabel)((0, slice_1["default"])(__spreadArray([], events, true), FOURTH_ELEMENT_INDEX)); }, [events]);
    var handleEventClick = react_1["default"].useCallback(function (event) {
        var eventFromHour = event.target;
        var eventId = (0, get_1["default"])(eventFromHour, 'dataset.eventid');
        if (!eventId) {
            return;
        }
        var requiredEvent = events.filter(function (hourEvent) { return hourEvent.id === Number(eventId); })[0];
        props.openEditModal(requiredEvent);
    }, [events, props]);
    return (react_1["default"].createElement("div", { className: bem.element('hour', {
            isToday: props.dayOfWeek.isToday,
            hasOneEvent: hasOneEvent,
            hasTwoEvents: hasTwoEvents,
            hasTreeEvents: hasTreeEvents,
            isExpanded: isExpanded
        }), ref: weekHourRef, onClick: handleEventClick, onContextMenu: function (e) {
            e.preventDefault();
            props.openCreateModal();
        } },
        events.map(renderEvent),
        hasMoreThanFourEvents && !isExpanded && (react_1["default"].createElement(form_1.Button, { link: true, className: bem.element('expand-button'), onClick: function () { return setIsExpanded(true); } }, formattedExpandLabel))));
}
exports["default"] = WeekHour;
