"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var form_1 = require("@steroidsjs/core/ui/form");
var Avatar_1 = __importDefault(require("@steroidsjs/core/ui/content/Avatar/Avatar"));
var nav_1 = require("@steroidsjs/core/ui/nav");
var content_1 = require("@steroidsjs/core/ui/content");
function CardView(props) {
    var bem = (0, hooks_1.useBem)('CardView');
    var hasContent = !!(props.title || props.buttons || props.links || props.description || props.children);
    return (react_1["default"].createElement("div", { className: bem(bem.block(), props.className), style: props.style },
        props.header && (react_1["default"].createElement("div", { className: bem.element('header', {
                withoutCover: !props.cover && hasContent
            }) },
            react_1["default"].createElement("div", { className: bem.element('header-data') },
                props.header.avatar && (react_1["default"].createElement(Avatar_1["default"], __assign({}, props.header.avatar, { className: bem(props.header.avatar.className, bem.element('header-avatar')) }))),
                react_1["default"].createElement("div", { className: bem.element('header-text-content') },
                    react_1["default"].createElement("h3", { className: bem.element('header-head') }, props.header.head),
                    react_1["default"].createElement("p", { className: bem.element('header-subhead') }, props.header.subhead))),
            props.header.menu && (react_1["default"].createElement("div", { className: bem.element('header-menu'), role: 'button' },
                react_1["default"].createElement(content_1.Menu, __assign({}, props.header.menu)))))),
        props.cover && (react_1["default"].createElement("div", { className: bem.element('cover') },
            react_1["default"].createElement("img", { src: props.cover, alt: 'Card cover img' }))),
        hasContent && (react_1["default"].createElement("div", { className: bem.element('content') },
            props.title && (react_1["default"].createElement("h3", { className: bem.element('title') }, props.title)),
            react_1["default"].createElement("div", { className: bem.element('content-inner') },
                props.description && (react_1["default"].createElement("p", { className: bem.element('description') }, props.description)),
                props.buttons && (react_1["default"].createElement("div", { className: bem.element('buttons') }, props.buttons.map(function (button, buttonIndex) { return (react_1["default"].createElement(form_1.Button, __assign({}, button, { key: buttonIndex }))); }))),
                props.links && (react_1["default"].createElement("div", { className: bem.element('links') }, props.links.map(function (link, linkIndex) { return (react_1["default"].createElement(nav_1.Link, __assign({}, link, { key: linkIndex }))); }))),
                props.children))),
        props.footer && (react_1["default"].createElement("div", { className: bem.element('footer') },
            react_1["default"].createElement("h3", { className: bem.element('footer-head') }, props.footer.head),
            react_1["default"].createElement("p", { className: bem.element('footer-subhead') }, props.footer.subhead)))));
}
exports["default"] = CardView;
