"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var Detail_1 = require("@steroidsjs/core/ui/content/Detail/Detail");
var Controls_1 = __importDefault(require("@steroidsjs/core/ui/nav/Controls"));
function DetailView(props) {
    var bem = (0, hooks_1.useBem)('DetailView');
    return (react_1["default"].createElement("div", { className: bem(bem.block(), props.className), ref: props.resizedNodeRef },
        (props.title || props.controls) && (react_1["default"].createElement("div", { className: bem.element('header') },
            props.title && (react_1["default"].createElement("div", { className: bem.element('title') }, props.title)),
            props.controls && (react_1["default"].createElement(Controls_1["default"], { items: props.controls, className: bem.element('controls') })))),
        react_1["default"].createElement("div", { className: bem.element('table-container') },
            react_1["default"].createElement("table", { className: bem.element('table') },
                react_1["default"].createElement("tbody", null, props.rows.map(function (row, rowIndex) {
                    if (props.layout === Detail_1.DetailLayoutEnum.Vertical) {
                        return (react_1["default"].createElement(react_1["default"].Fragment, { key: rowIndex },
                            react_1["default"].createElement("tr", { className: bem.element('row') }, row.map(function (cell, cellIndex) { return (react_1["default"].createElement("th", { key: cellIndex, colSpan: cell.colspan, className: bem(bem.element('label', {
                                    size: props.size
                                }), cell.labelClassName) }, cell.label)); })),
                            react_1["default"].createElement("tr", { className: bem.element('row') }, row.map(function (cell, cellIndex) { return (react_1["default"].createElement("td", { key: cellIndex, colSpan: cell.colspan, className: bem(bem.element('value', {
                                    size: props.size
                                }), cell.contentClassName) }, cell.value)); }))));
                    }
                    return (react_1["default"].createElement("tr", { key: rowIndex, className: bem.element('row') }, row.map(function (cell, cellIndex) { return (react_1["default"].createElement(react_1["default"].Fragment, { key: cellIndex },
                        react_1["default"].createElement("th", { colSpan: Detail_1.constants.TABLE_HEAD_COLSPAN, className: bem(bem.element('label', {
                                size: props.size
                            }), cell.labelClassName) }, cell.label),
                        react_1["default"].createElement("td", { colSpan: cell.colspan, className: bem(bem.element('value', {
                                size: props.size
                            }), cell.contentClassName) }, cell.value))); })));
                }))))));
}
exports["default"] = DetailView;
