"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var typography_1 = require("@steroidsjs/core/ui/typography");
var form_1 = require("@steroidsjs/core/ui/form");
function KanbanColumnView(props) {
    var bem = (0, hooks_1.useBem)('KanbanColumnView');
    var Draggable = props.draggableComponent;
    var Droppable = props.droppableComponent;
    var _a = props.column, id = _a.id, title = _a.title, tasks = _a.tasks;
    return (react_1["default"].createElement(Draggable, { draggableId: id.toString(), index: props.columnIndex }, function (providedDraggable) { return (react_1["default"].createElement("div", __assign({ className: bem.block() }, providedDraggable.draggableProps, { ref: providedDraggable.innerRef }),
        react_1["default"].createElement("div", __assign({ className: bem.element('header') }, providedDraggable.dragHandleProps),
            react_1["default"].createElement(typography_1.Title, { className: bem.element('title'), content: title, type: 'h3' },
                react_1["default"].createElement("span", { className: bem.element('tasks-count') }, tasks.length))),
        react_1["default"].createElement(Droppable, { droppableId: id.toString(), type: "task" }, function (providedDroppable) { return (react_1["default"].createElement("div", __assign({ className: bem.element('content'), ref: providedDroppable.innerRef }, providedDroppable.droppableProps),
            tasks.map(function (task, taskIndex) { return (props.renderTask(task, props.column.id, taskIndex)); }),
            providedDroppable.placeholder)); }),
        react_1["default"].createElement("div", { className: bem.element('button') },
            react_1["default"].createElement(form_1.Button, { size: "sm", color: 'basic', icon: "add", onClick: function () { return props.onOpenCreateTaskModal(props.column.id); }, block: true })))); }));
}
exports["default"] = KanbanColumnView;
