"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importStar(require("react"));
var Modal_1 = __importDefault(require("@steroidsjs/core/ui/modal/Modal/Modal"));
var enums_1 = require("@steroidsjs/core/ui/content/Kanban/enums");
var hooks_1 = require("@steroidsjs/core/hooks");
var CreateOrEditTaskModalContent_1 = __importDefault(require("./views/CreateOrEditTaskModalContent"));
var TaskDetailsModalContent_1 = __importDefault(require("./views/TaskDetailsModalContent"));
function KanbanModalView(props) {
    var bem = (0, hooks_1.useBem)('KanbanModalView');
    var renderModalContent = (0, react_1.useCallback)(function (modalType) {
        switch (modalType) {
            case enums_1.KanbanModalTypeEnum.CREATE:
                return (react_1["default"].createElement(CreateOrEditTaskModalContent_1["default"], { bem: bem, formId: props.formId, columns: props.columns, columnId: props.columnId, tags: props.tags, assigners: props.assigners, submitButtonLabel: __('Создать'), onSubmit: props.onSubmit }));
            case enums_1.KanbanModalTypeEnum.DETAILS:
                return (react_1["default"].createElement(TaskDetailsModalContent_1["default"], { bem: bem, task: props.task }));
            case enums_1.KanbanModalTypeEnum.EDIT:
                return (react_1["default"].createElement(CreateOrEditTaskModalContent_1["default"], { bem: bem, formId: props.formId, task: props.task, columns: props.columns, columnId: props.columnId, tags: props.tags, assigners: props.assigners, submitButtonLabel: __('Сохранить'), onSubmit: props.onSubmit }));
            default:
                return null;
        }
    }, [bem, props.assigners, props.columnId, props.columns, props.formId, props.onSubmit, props.tags, props.task]);
    var renderModalButton = (0, react_1.useCallback)(function (modalType) { return modalType !== enums_1.KanbanModalTypeEnum.CREATE
        ? [{
                icon: enums_1.KanbanModalTypeEnum.getModalIconByType(modalType),
                onClick: props.onToggleModalType
            }]
        : null; }, [props.modalType]);
    return (react_1["default"].createElement(Modal_1["default"], { className: bem.block(), title: props.title, onClose: props.onClose, size: "lg", buttons: renderModalButton(props.modalType) }, renderModalContent(props.modalType)));
}
exports["default"] = KanbanModalView;
