"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var form_1 = require("@steroidsjs/core/reducers/form");
var form_2 = require("@steroidsjs/core/ui/form");
var TaskTags_1 = __importDefault(require("../../../../../TaskTags"));
require("./TagsSelector.scss");
function TagsSelector(props) {
    var bem = (0, hooks_1.useBem)('TagsSelector');
    var selectedTags = (0, hooks_1.useSelector)(function (state) { return (0, form_1.getFormValues)(state, props.formId); }).tags;
    var taskTags = (0, react_1.useMemo)(function () { return (props.tags.filter(function (tag) { return selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.includes(tag.id); })); }, [props.tags, selectedTags]);
    var tagsList = (0, react_1.useMemo)(function () { return (props.tags.map(function (tag) { return ({
        id: tag.id,
        label: tag.message,
        contentType: 'icon',
        contentSrc: react_1["default"].createElement("div", { className: bem.element('tag-color', tag.type) })
    }); })); }, [bem, props.tags]);
    return (react_1["default"].createElement("div", { className: bem.block() },
        !!(selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.length) && (react_1["default"].createElement(TaskTags_1["default"], { tags: taskTags })),
        react_1["default"].createElement(form_2.DropDownField, { attribute: "tags", placeholder: __('Выберите теги'), multiple: true, items: tagsList, selectedIds: selectedTags, autoComplete: true, outline: true })));
}
exports["default"] = TagsSelector;
