"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var Avatar_1 = __importDefault(require("@steroidsjs/core/ui/content/Avatar/Avatar"));
var typography_1 = require("@steroidsjs/core/ui/typography");
var TaskTags_1 = __importDefault(require("../TaskTags"));
function KanbanTaskView(props) {
    var bem = (0, hooks_1.useBem)('KanbanTaskView');
    var _a = props.task, id = _a.id, title = _a.title, description = _a.description, tags = _a.tags, assigner = _a.assigner, priority = _a.priority;
    var Draggable = props.draggableComponent;
    return (react_1["default"].createElement(Draggable, { draggableId: id.toString(), index: props.index }, function (provided) {
        var _a;
        return (react_1["default"].createElement("div", __assign({ className: bem.block() }, provided.draggableProps, provided.dragHandleProps, { ref: provided.innerRef }),
            react_1["default"].createElement("div", { className: bem.element('wrapper') },
                react_1["default"].createElement("div", { className: bem.element('content') },
                    react_1["default"].createElement("div", { className: bem.element('header') },
                        react_1["default"].createElement("h4", { className: bem.element('title'), "aria-hidden": "true", onClick: function () { return props.onOpenTaskDetailsModal(props.task, props.columnId); } },
                            react_1["default"].createElement("span", { className: bem.element('task-id') }, __("#".concat(id, " "))),
                            title)),
                    description && (react_1["default"].createElement(typography_1.Text, { type: 'body2', content: description, className: bem.element('description') }))),
                react_1["default"].createElement("div", { className: bem.element('footer') },
                    tags && (react_1["default"].createElement(TaskTags_1["default"], { tags: tags })),
                    assigner && (react_1["default"].createElement("div", { className: bem.element('assigner') },
                        react_1["default"].createElement(Avatar_1["default"], { src: (_a = assigner.avatar) === null || _a === void 0 ? void 0 : _a.src, title: "".concat(assigner.firstName, " ").concat(assigner.lastName), size: 'sm' }))))),
            priority && (react_1["default"].createElement("span", { className: bem.element('priority', !!priority && "".concat(priority.type)) }))));
    }));
}
exports["default"] = (0, react_1.memo)(KanbanTaskView);
