"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var isString_1 = __importDefault(require("lodash-es/isString"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var hooks_1 = require("@steroidsjs/core/hooks");
function ButtonView(props) {
    var _a;
    var bem = (0, hooks_1.useBem)('ButtonView');
    var renderLabel = function () {
        var title = props.label && (0, isString_1["default"])(props.label)
            ? props.label
            : (props.hint || null);
        return (React.createElement(React.Fragment, null,
            props.isLoading && (React.createElement(Icon_1["default"], { className: bem.element('loader'), name: 'loading_icon_thick', tabIndex: -1 })),
            !props.isLoading && (React.createElement("span", { title: props.hint, className: bem.element(props.link ? 'link' : 'label') },
                props.icon && (React.createElement(Icon_1["default"], { name: props.icon, title: title, className: bem.element('icon', !props.label && 'without-label') })),
                React.createElement("span", { className: bem.element('text') }, props.children)))));
    };
    var renderBadge = function () {
        var _a;
        if (!props.badge || !props.badge.enable) {
            return null;
        }
        return (React.createElement("span", { className: bem(bem.element('badge', (_a = {},
                _a["".concat(props.badge.color)] = !!props.badge.color,
                _a)), props.badge.className) }, props.badge.value));
    };
    var className = bem(bem.block((_a = {
            button: !props.link
        },
        _a["color_".concat(props.color)] = props.color && !props.outline,
        _a["outline_".concat(props.color)] = props.outline,
        _a.outline = props.outline,
        _a.size = props.size,
        _a.disabled = props.disabled,
        _a.submitting = props.submitting,
        _a.loading = props.isLoading,
        _a.failed = props.isFailed,
        _a.link = props.link,
        _a.block = props.block,
        _a["tag-".concat(props.tag)] = !!props.tag,
        _a)), props.className);
    if (props.tag === 'a') {
        return (React.createElement("a", { className: className, href: props.url, onClick: props.onClick, style: props.style, target: props.target },
            renderLabel(),
            renderBadge()));
    }
    return (React.createElement("button", { title: props.hint, type: props.type, disabled: props.disabled || props.isLoading, onClick: props.onClick, style: props.style, className: className },
        renderLabel(),
        renderBadge()));
}
exports["default"] = ButtonView;
