"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var FileField_1 = require("@steroidsjs/core/ui/form/FileField/FileField");
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
function FileFieldItemView(props) {
    var bem = (0, hooks_1.useBem)('FileFieldItemView');
    var isLoading = props.progress && props.progress.percent !== 100;
    var isWall = props.filesLayout === FileField_1.FilesLayout.wall;
    var renderLink = React.useCallback(function () { return (React.createElement("a", { className: bem.element('link'), title: props.title, href: props.error ? '#' : props.item.url, target: 'blank' }, isWall
        ? React.createElement(Icon_1["default"], { name: 'view' })
        : props.title)); }, [bem, props.title, props.error, props.item.url, isWall]);
    var renderProgressBar = React.useCallback(function () { return (React.createElement("div", { className: bem.element('progress-track') },
        React.createElement("div", { className: bem.element('progress-bar'), style: { width: "".concat(props.progress.percent, "%") } }))); }, [bem, props.progress]);
    var renderLoadingState = React.useCallback(function () { return (React.createElement("div", { className: bem.element('left') },
        React.createElement("div", { className: bem.element('icon-wrapper', 'loading') },
            React.createElement(Icon_1["default"], { className: bem.element('icon-loading'), name: 'loading_default' })),
        React.createElement("div", { className: bem.element('content') },
            React.createElement("span", { className: bem.element('title', 'loading') }, props.title),
            renderProgressBar(),
            React.createElement("span", { className: bem.element('loading-text') }, __('Uploading...'))))); }, [bem, props.title, renderProgressBar]);
    var renderFileItem = React.useCallback(function () { return (React.createElement("div", { className: bem.element('left') },
        props.image
            ? (React.createElement("div", { className: bem.element('image'), style: { backgroundImage: "url(".concat(props.image.url, ")") } }))
            : (React.createElement("div", { className: bem.element('icon-wrapper') },
                React.createElement(Icon_1["default"], { className: bem.element('icon'), name: props.imagesOnly ? 'img_box' : 'clip' }))),
        renderLink(),
        React.createElement("span", { className: bem.element('title') }, props.title))); }, [bem, props.image, props.imagesOnly, props.title, renderLink]);
    return (React.createElement("div", { className: bem.block({
            error: !!props.error,
            images: props.imagesOnly,
            isWall: isWall
        }) },
        isLoading
            ? renderLoadingState()
            : renderFileItem(),
        props.showRemove && (React.createElement(Icon_1["default"], { name: props.customRemoveIcon || 'trash', className: bem.element('remove', { isLoading: isLoading }), onClick: props.onRemove })),
        React.createElement("div", { className: bem.element('overlay') })));
}
exports["default"] = FileFieldItemView;
