"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var isString_1 = __importDefault(require("lodash-es/isString"));
var hooks_1 = require("@steroidsjs/core/hooks");
var Field_1 = __importDefault(require("@steroidsjs/core/ui/form/Field"));
var Button_1 = __importDefault(require("@steroidsjs/core/ui/form/Button"));
var react_use_1 = require("react-use");
var react_1 = require("react");
function FormView(props) {
    var bem = (0, hooks_1.useBem)('FormView');
    var formRef = (0, react_1.useRef)(null);
    // Auto focus
    (0, react_use_1.useMount)(function () {
        if (props.autoFocus) {
            var inputEl_1 = formRef.current.querySelector('input:not([type=hidden])');
            setTimeout(function () {
                if (inputEl_1 && inputEl_1.focus) {
                    inputEl_1.focus();
                }
            }, 10);
        }
    });
    return (React.createElement("form", { ref: formRef, className: bem(bem.block(), props.className), onSubmit: props.onSubmit, style: props.style },
        props.children,
        (props.fields || []).map(function (field, index) { return (React.createElement(Field_1["default"], __assign({ key: index }, ((0, isString_1["default"])(field) ? { attribute: field } : field)))); }),
        props.submitLabel && (React.createElement(Button_1["default"], { type: 'submit', label: props.submitLabel }))));
}
exports["default"] = React.memo(FormView);
