"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable consistent-return */
var React = __importStar(require("react"));
var nav_1 = require("@steroidsjs/core/ui/nav");
var Nav_1 = __importDefault(require("@steroidsjs/core/ui/nav/Nav"));
var hooks_1 = require("@steroidsjs/core/hooks");
var form_1 = require("@steroidsjs/core/ui/form");
var modal_1 = require("@steroidsjs/core/actions/modal");
var Text_1 = __importDefault(require("@steroidsjs/core/ui/typography/Text/Text"));
var content_1 = require("@steroidsjs/core/ui/content");
var renderIcon_1 = __importDefault(require("../../utils/renderIcon"));
function HeaderView(props) {
    var _a, _b, _c, _d, _e;
    var bem = (0, hooks_1.useBem)('HeaderView');
    var dispatch = (0, hooks_1.useDispatch)();
    var renderAuthBlock = React.useCallback(function () {
        var _a, _b;
        return (React.createElement(form_1.Button, __assign({ outline: true, color: 'basic', toRoute: (_a = props.authParams) === null || _a === void 0 ? void 0 : _a.toRoute, className: bem.element('auth-btn'), size: props.size }, (_b = props.authParams) === null || _b === void 0 ? void 0 : _b.buttonProps, { onClick: function () { var _a; return dispatch((0, modal_1.openModal)((_a = props.authParams) === null || _a === void 0 ? void 0 : _a.modal)); } }), __('Войти')));
    }, [bem, dispatch, (_a = props.authParams) === null || _a === void 0 ? void 0 : _a.buttonProps, (_b = props.authParams) === null || _b === void 0 ? void 0 : _b.modal, (_c = props.authParams) === null || _c === void 0 ? void 0 : _c.toRoute, props.size]);
    var renderUserBlock = React.useCallback(function () {
        var _a, _b, _c;
        if (!props.user) {
            return;
        }
        return (React.createElement("div", { className: bem.element('menu') },
            React.createElement(Text_1["default"], { className: bem.element('menu-name') }, (_a = props.user) === null || _a === void 0 ? void 0 : _a.name),
            React.createElement(content_1.Menu, __assign({ icon: (React.createElement(content_1.Avatar, __assign({ size: props.size, className: bem.element('menu-avatar') }, (_b = props.user) === null || _b === void 0 ? void 0 : _b.avatar))) }, (_c = props.user) === null || _c === void 0 ? void 0 : _c.menu))));
    }, [bem, props.size, props.user]);
    var renderBurger = React.useCallback(function () {
        var _a;
        return (React.createElement("div", { className: bem.element('burger') },
            React.createElement(content_1.Icon, { name: !props.isBurgerOpened ? 'sort' : 'cross_12x12', className: bem.element('burger-icon'), onClick: props.toggleBurger }),
            React.createElement("div", { className: bem.element('burger-menu', {
                    isVisible: props.isBurgerOpened
                }) },
                React.createElement("ul", { className: bem.element('burger-list') }, (_a = props.burgerMenu.links) === null || _a === void 0 ? void 0 : _a.map(function (linkProps, linkIndex) { return (React.createElement("li", { key: linkIndex, className: "burger-item" },
                    React.createElement(nav_1.Link, __assign({}, linkProps)))); })))));
    }, [bem, (_d = props.burgerMenu) === null || _d === void 0 ? void 0 : _d.links, props.isBurgerOpened, props.toggleBurger]);
    return (React.createElement("header", { className: bem(bem.block({
            size: props.size
        }), props.className), style: props.style },
        props.logo && (React.createElement(nav_1.Link, __assign({ className: bem.element('logo'), toRoute: 'root', size: props.size }, props.logo.linkProps),
            props.logo.icon && ((0, renderIcon_1["default"])(props.logo.icon, {
                className: bem.element('logo-image')
            })),
            React.createElement("span", { className: bem.element('logo-title') }, props.logo.title || ''))),
        props.nav && (React.createElement(Nav_1["default"], __assign({ size: props.size, layout: 'navbar', className: bem.element('nav') }, props.nav))),
        (props.burgerMenu || props.authParams || props.user) && (React.createElement("div", { className: bem.element('interaction') },
            ((_e = props === null || props === void 0 ? void 0 : props.authParams) === null || _e === void 0 ? void 0 : _e.isAuth) ? renderAuthBlock() : renderUserBlock(),
            props.burgerMenu && renderBurger())),
        props.children));
}
exports["default"] = HeaderView;
