"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var nav_1 = require("@steroidsjs/core/ui/nav");
var SidebarUser_1 = __importDefault(require("./SidebarUser"));
var SidebarLogo_1 = __importDefault(require("./SidebarLogo"));
var FooterIcons_1 = __importDefault(require("./FooterIcons"));
function SidebarView(props) {
    var bem = (0, useBem_1["default"])('SidebarView');
    return (react_1["default"].createElement("aside", { className: bem(bem.block({
            isOpened: props.isOpened,
            hasSeparatedItem: props.hasSeparatedNavItem
        }), props.className), style: props.style },
        react_1["default"].createElement("header", { className: bem.element('header') },
            react_1["default"].createElement(SidebarLogo_1["default"], { icon: props.logo.icon, label: props.logo.label, toggleSidebar: props.toggleSidebar }),
            react_1["default"].createElement(SidebarUser_1["default"], { menu: props.menu, name: props.user.name, picture: props.user.picture })),
        react_1["default"].createElement(nav_1.Nav, { items: props.items, layout: "icon", className: bem.element('nav'), onChange: props === null || props === void 0 ? void 0 : props.onClickNav }),
        react_1["default"].createElement("footer", { className: bem.element('footer') },
            react_1["default"].createElement(FooterIcons_1["default"], { footerIcons: props.footerIcons, isShink: !props.isOpened })),
        react_1["default"].createElement("div", { className: bem.element('trigger'), onClick: props.toggleSidebar })));
}
exports["default"] = SidebarView;
