"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
function FlexGridView(props) {
    var _a;
    var bem = (0, hooks_1.useBem)('FlexGridView');
    var halfColGap = props.colGap / 2;
    var hasItems = !!((_a = props.items) === null || _a === void 0 ? void 0 : _a.length);
    var colGapStyle = hasItems
        ? {
            marginRight: -halfColGap,
            marginLeft: -halfColGap
        }
        : {
            columnGap: props.colGap
        };
    return (React.createElement("div", { className: bem(bem.block({
            wrap: props.wrap,
            align: props.align,
            direction: props.direction,
            justify: props.justify
        }), props.className), style: __assign(__assign(__assign({}, props.style), colGapStyle), { rowGap: props.rowGap }) },
        hasItems && props.items.map(function (item, index) { return (React.createElement("div", { key: index, className: bem(bem.element('item', {
                col: item.col,
                lg: item.lg,
                md: item.md,
                sm: item.sm,
                offset: item.offset
            }), props.itemClassName), style: {
                paddingRight: halfColGap,
                paddingLeft: halfColGap,
                order: item.order
            } }, item.content)); }),
        props.children));
}
exports["default"] = FlexGridView;
