"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var Format_1 = __importDefault(require("@steroidsjs/core/ui/format/Format"));
var get_1 = __importDefault(require("lodash-es/get"));
var nav_1 = require("@steroidsjs/core/ui/nav");
var content_1 = require("@steroidsjs/core/ui/content");
function ContentColumnView(props) {
    var _a, _b, _c, _d, _e;
    var bem = (0, useBem_1["default"])('ContentColumnView');
    var hasLink = !!((_a = props.link) === null || _a === void 0 ? void 0 : _a.attribute);
    var hasPicture = !!((_b = props.picture) === null || _b === void 0 ? void 0 : _b.attribute);
    var hasIcon = !!((_c = props.icon) === null || _c === void 0 ? void 0 : _c.attribute);
    var hasSubtitle = !!props.subtitleAttribute;
    var hasTextData = !!props.attribute || !!props.subtitleAttribute || hasLink;
    var renderFormat = function () { return (react_1["default"].createElement(Format_1["default"], __assign({}, props, (props.formatter || {}), { attribute: hasLink ? props.link.attribute : props.attribute }))); };
    var renderValue = function () {
        var _a;
        if (hasLink) {
            return (react_1["default"].createElement(nav_1.Link, __assign({}, props.link.linkProps, { url: (0, get_1["default"])(props.item, (_a = props.link) === null || _a === void 0 ? void 0 : _a.urlAttribute), className: bem.element('link') }), renderFormat()));
        }
        return (react_1["default"].createElement("span", { className: bem.element('value') }, renderFormat()));
    };
    return (react_1["default"].createElement("div", { className: bem(bem.block({
            size: props.size,
            isLeft: ((_d = props.picture) === null || _d === void 0 ? void 0 : _d.isLeft) || ((_e = props.icon) === null || _e === void 0 ? void 0 : _e.isLeft)
        })) },
        hasTextData && (react_1["default"].createElement("div", { className: bem.element('data') },
            renderValue(),
            hasSubtitle && react_1["default"].createElement("span", { className: bem.element('subtitle') }, (0, get_1["default"])(props.item, props.subtitleAttribute)))),
        hasPicture && (react_1["default"].createElement("span", { className: bem.element('picture') },
            react_1["default"].createElement("img", { src: (0, get_1["default"])(props.item, props.picture.attribute), alt: "cell element" }))),
        hasIcon && (react_1["default"].createElement(content_1.Icon, { name: (0, get_1["default"])(props.item, props.icon.attribute), className: bem.element('icon') }))));
}
exports["default"] = ContentColumnView;
