"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
require("./DiagramColumnView.scss");
var DiagramType;
(function (DiagramType) {
    DiagramType["HORIZONTAL"] = "horizontal";
    DiagramType["VERTICAL"] = "vertical";
    DiagramType["CIRCLE"] = "circle";
})(DiagramType || (DiagramType = {}));
function DiagramColumnView(props) {
    var _a, _b, _c, _d, _e, _f;
    var bem = (0, useBem_1["default"])('DiagramColumnView');
    var isHorizontal = ((_a = props.diagram) === null || _a === void 0 ? void 0 : _a.type) === DiagramType.HORIZONTAL;
    var isVertical = ((_b = props.diagram) === null || _b === void 0 ? void 0 : _b.type) === DiagramType.VERTICAL;
    var isCircle = ((_c = props.diagram) === null || _c === void 0 ? void 0 : _c.type) === DiagramType.CIRCLE;
    var getItemData = function (item) { return ({
        itemPercentage: props.item[item === null || item === void 0 ? void 0 : item.percentageAttribute],
        itemColor: item === null || item === void 0 ? void 0 : item.color
    }); };
    var renderDiagram = function (diagramItems, hasPercentSign, hasSubtitle, fillingProperty) {
        var _a;
        if (fillingProperty === void 0) { fillingProperty = null; }
        return (react_1["default"].createElement("div", { className: bem(bem.block({
                size: props.size,
                type: (_a = props.diagram) === null || _a === void 0 ? void 0 : _a.type
            })) },
            react_1["default"].createElement("div", { className: bem.element('wrapper') },
                react_1["default"].createElement("div", { className: bem.element('wrapper-diagrams') }, diagramItems.map(function (item, itemIndex) {
                    var _a;
                    var _b;
                    var _c = getItemData(item), itemColor = _c.itemColor, itemPercentage = _c.itemPercentage;
                    return (react_1["default"].createElement("div", { key: itemIndex, className: bem.element('diagram', {
                            type: (_b = props.diagram) === null || _b === void 0 ? void 0 : _b.type
                        }) },
                        react_1["default"].createElement("span", { className: bem.element('diagram-percentage') },
                            itemPercentage,
                            hasPercentSign && ' %'),
                        react_1["default"].createElement("div", { className: bem.element('diagram-filling', {
                                color: itemColor
                            }), style: (_a = {}, _a[fillingProperty] = "".concat(itemPercentage, "%"), _a) })));
                })),
                hasSubtitle && (react_1["default"].createElement("span", { className: bem.element('subtitle') }, props.item[props.subtitleAttribute])))));
    };
    if (isHorizontal) {
        return (renderDiagram((_d = props.diagram) === null || _d === void 0 ? void 0 : _d.items, true, false, 'width'));
    }
    if (isVertical) {
        return (renderDiagram((_e = props.diagram) === null || _e === void 0 ? void 0 : _e.items, true, false, 'height'));
    }
    if (isCircle) {
        return (renderDiagram((_f = props.diagram) === null || _f === void 0 ? void 0 : _f.items, false, !!props.subtitleAttribute));
    }
    return null;
}
exports["default"] = DiagramColumnView;
