"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var Format_1 = __importDefault(require("@steroidsjs/core/ui/format/Format"));
var content_1 = require("@steroidsjs/core/ui/content");
var DEFAULT_PADDING_LEFT = 32;
var PADDING_WITH_ICON = 0;
var PADDING_WITHOUT_ICON = 24;
function TreeColumnView(props) {
    var bem = (0, hooks_1.useBem)('TreeColumnView');
    var levelPadding = props.levelPadding || DEFAULT_PADDING_LEFT;
    var paddingBasedOnIcon = props.item.hasItems ? PADDING_WITH_ICON : PADDING_WITHOUT_ICON;
    var renderFormat = function () { return (react_1["default"].createElement(Format_1["default"], __assign({}, props, (props.formatter || {}), { attribute: props.attribute }))); };
    var renderValue = function () { return (react_1["default"].createElement("span", { className: bem.element('value') }, renderFormat())); };
    return (react_1["default"].createElement("div", { className: bem.block(bem.block({
            size: props.size
        })) },
        react_1["default"].createElement("div", { className: bem.element('data'), style: {
                paddingLeft: "".concat(props.item.level * levelPadding + paddingBasedOnIcon, "px")
            } },
            props.item.hasItems && (react_1["default"].createElement(content_1.Icon, { name: 'expand_right', className: bem.element('icon', {
                    opened: props.item.isOpened
                }), onClick: function () { return props.item.onTreeItemClick(props.item.uniqueId, props.item); } })),
            renderValue())));
}
exports["default"] = TreeColumnView;
