"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var content_1 = require("@steroidsjs/core/ui/content");
var renderArrowStep = function (bem, onClick, iconName, rotate, rounding, disabled) {
    if (rotate === void 0) { rotate = false; }
    return (React.createElement("li", { className: bem.element('page', {
            'rounding-left': rounding.left,
            'rounding-right': rounding.right,
            hasIcon: true,
            disabled: disabled
        }) },
        React.createElement("button", { className: bem.element('page-button', {
                hasIcon: true
            }), onClick: function () { return onClick(); }, disabled: disabled },
            React.createElement(content_1.Icon, { tabIndex: -1, className: bem.element('page-icon', {
                    rotate: rotate
                }), name: iconName }))));
};
function PaginationButtonView(props) {
    var bem = (0, hooks_1.useBem)('PaginationButtonView');
    return (React.createElement("ul", { className: bem(bem.block({
            size: props.size
        }), props.className) },
        props.showEdgeSteps
            && renderArrowStep(bem, props.onSelectFirst, 'double_arrow_left', false, { left: true }, props.isFirstPage),
        props.showSteps
            && renderArrowStep(bem, props.onSelectPrev, 'arrow_left_24x24', false, {}, props.isFirstPage),
        props.pages.map(function (item, index) { return (React.createElement("li", { key: index, className: bem.element('page', {
                hidden: !item.page,
                active: item.isActive
            }) },
            React.createElement("button", { className: bem.element('page-button', {
                    hidden: !item.page
                }), onClick: function () { return props.onSelect(item.page); } }, item.label))); }),
        props.showSteps
            && renderArrowStep(bem, props.onSelectNext, 'arrow_left_24x24', true, {}, props.isLastPage),
        props.showEdgeSteps
            && renderArrowStep(bem, props.onSelectLast, 'double_arrow_left', true, { right: true }, props.isLastPage)));
}
exports["default"] = PaginationButtonView;
