"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var Link_1 = __importDefault(require("@steroidsjs/core/ui/nav/Link"));
var hooks_1 = require("@steroidsjs/core/hooks");
var content_1 = require("@steroidsjs/core/ui/content");
var renderIcon_1 = __importDefault(require("../../utils/renderIcon"));
function BreadcrumbsView(props) {
    var bem = (0, hooks_1.useBem)('BreadcrumbsView');
    var items = props.items || [];
    var renderLink = React.useCallback(function (item, children) { return (React.createElement(Link_1["default"], { toRoute: item.id, toRouteParams: props.routeParams, href: item.id }, children)); }, [props.routeParams]);
    var renderHomeIcon = React.useCallback(function () { return (props.customIcon
        ? (0, renderIcon_1["default"])(props.customIcon, { className: bem.element('custom-icon') })
        : (React.createElement(content_1.Icon, { name: 'home', className: bem.element('icon') }))); }, [bem, props.customIcon]);
    return (React.createElement("nav", { className: bem(bem.block(), props.className), "aria-label": 'breadcrumb' },
        React.createElement("ol", { className: bem.element('list') }, items.map(function (item, index) {
            var isLastItem = items.length === index + 1;
            var isFirstItem = index === 0;
            return (React.createElement("li", { key: item.id || index, className: bem.element('item') },
                isFirstItem && item.id && renderLink(item, props.showIcon ? renderHomeIcon() : item.title),
                !isFirstItem && !isLastItem && item.id && renderLink(item, item.title),
                (isLastItem || !item.id) && (React.createElement("span", null, props.pageTitle || item.title))));
        }))));
}
exports["default"] = BreadcrumbsView;
