"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var form_1 = require("@steroidsjs/core/ui/form");
function ButtonGroupView(props) {
    var bem = (0, hooks_1.useBem)('ButtonGroupView');
    return (react_1["default"].createElement("ul", { className: bem(bem.block({
            size: props.size
        }), props.className), style: props.style }, props.items.map(function (item, index) {
        var isActive = props.activeButton === item.id;
        return (react_1["default"].createElement("li", { key: index, className: item.className ? item.className : null },
            react_1["default"].createElement(form_1.Button, __assign({ className: bem.element('button', {
                    "default": !isActive,
                    active: isActive
                }), label: item.label, onClick: function () { return props.onClick(item.id); } }, props.buttonProps))));
    })));
}
exports["default"] = ButtonGroupView;
