"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var Button_1 = __importDefault(require("@steroidsjs/core/ui/form/Button"));
var hooks_1 = require("@steroidsjs/core/hooks");
var DEFAULT_ICON = 'add';
function NavIconView(props) {
    var bem = (0, hooks_1.useBem)('NavIconView');
    return (React.createElement("div", { className: bem(bem.block(), props.className) },
        React.createElement("ul", { className: bem.element('list') }, props.items.map(function (item, index) {
            var _a;
            var isDisabled = item.disabled;
            var isActive = item.isActive;
            var isActiveNested = item.isActiveNested;
            var isBorder = item.border;
            return (React.createElement("li", { key: item.id || index, className: bem(bem.element('list-item', {
                    active: isActive,
                    disabled: isDisabled,
                    nestedActive: isActiveNested,
                    hasItems: !!item.items,
                    hasBorder: isBorder
                }), props.navClassName) },
                React.createElement(Button_1["default"], __assign({ icon: props.icon ? props.icon : DEFAULT_ICON, link: true, onClick: function () { return props.onClick(item, index); } }, item, { label: item.label, hint: item.hint || item.label || null }, item.itemProps)),
                !isDisabled && (isActive || isActiveNested) && (React.createElement("ul", { className: bem.element('list-item-nested') }, (_a = item.items) === null || _a === void 0 ? void 0 : _a.map(function (nestedItem, nestedItemIndex) { return (React.createElement("li", { key: nestedItemIndex, className: bem.element('list-item-nested-item', {
                        active: nestedItem.isActive
                    }) },
                    React.createElement(Button_1["default"], __assign({ link: true, onClick: function () { return props.onClick(nestedItem, nestedItemIndex); } }, nestedItem, { label: nestedItem.label, hint: item.hint })))); })))));
        })),
        React.createElement("div", { className: bem.element('content') }, props.children)));
}
exports["default"] = NavIconView;
